/*
 * TLGB_Pagine_Prog_Decimali.c
 *
 *  Created on: 29 nov 2016
 *      Author: gozzini.davide
 */

//==============================================================================
// Include files

#include "stdio.h"

#include "drivers/my_timer.h"
#include "drivers/my_LCD.h"

#include "TLGB/TLGB_Messaggi.h"
#include "TLGB/TLGB_flash.h"
#include "TLGB/TLGB_Funzioni.h"

#include "TLGB/PAGINE_PROG/TLGB_Pagine_Prog.h"
#include "TLGB/PAGINE_PROG/TLGB_Pagine_Prog_Decimali.h"

#include "main.h"

//==============================================================================
// Constants

//==============================================================================
// Types

//==============================================================================
// Static global variables

//==============================================================================
// Static functions

//==============================================================================
// Global variables

volatile decimali_lvl1 decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;

//==============================================================================
// Global functions

void gestione_menu_decimali_lvl1 (E_Stazioni numero_stazione)
{
	switch(decimali_lvl1_selezionato)
	{
		case decimali_lvl1_00:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S00]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S00]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S01]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S01]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S00]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_01:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S00]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S00]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S01]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S01]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S01]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_02:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S02]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S02]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S03]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S03]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S02]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_03:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S02]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S02]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S03]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S03]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S03]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_04:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S04]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S04]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S05]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S05]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S04]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_05:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S04]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S04]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S05]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S05]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S05]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_06:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S06]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S06]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S07]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S07]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S06]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_07:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S06]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S06]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S07]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S07]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S07]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_08:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S08]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S08]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S09]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S09]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S08]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_09:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S08]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S08]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S09]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S09]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S09]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_10:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S10]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S10]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S11]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S11]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S10]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_11:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S10]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S10]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S11]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S11]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S11]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_12:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S12]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S12]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S13]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S13]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S12]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_13:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S12]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S12]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S13]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S13]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S13]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_14:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S14]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S14]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S15]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S15]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S14]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_15:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S14]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S14]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S15]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S15]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S15]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_16:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S16]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S16]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S17]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S17]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S16]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_17:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S16]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S16]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S17]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S17]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S17]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_18:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S18]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S18]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S19]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S19]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(2, 3, 1, &ricetta.decimali[S18]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
		case decimali_lvl1_19:
		{
			if(refresh_schermo_prog == 1)
			{
				refresh_schermo_prog = 0;
				LCD_Display_Clear();
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S18]);
				LCD_WriteLine(1,MSG);
				sprintf(MSG, "- %u              Num", ricetta.decimali[S18]);
				LCD_WriteLine(2,MSG);
				sprintf(MSG, "%s", messaggi[salva.lingua][messaggio_S19]);
				LCD_WriteLine(3,MSG);
				sprintf(MSG, "> %u              Num", ricetta.decimali[S19]);
				LCD_WriteLine(4,MSG);
			}

			switch(UltimoTastoPremuto)
			{
				case ENTER:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					leggi_scrivi_unsigned_long(4, 3, 1, &ricetta.decimali[S19]);
				}
				break;
				case FRECCIA_SU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato--;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagina_menu)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagine_totali;
						decimali_lvl1_selezionato--;
					}
				}
				break;
				case FRECCIA_GIU:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato++;
					if(decimali_lvl1_selezionato == decimali_lvl1_pagine_totali)
					{
						decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
						decimali_lvl1_selezionato++;
					}
				}
				break;
				case CLR:
				{
					UltimoTastoPremuto = KEY_NONE;
					refresh_schermo_prog = 1;
					decimali_lvl1_selezionato = decimali_lvl1_pagina_menu;
				}
				break;
			}
		}
		break;
	}
	return;
}
